#include "../../backend/support/logger.h"
#include "../../backend/free-tree/free-tree.h"
#include "flex-actions.h"
#include <stdlib.h>
#include <string.h>

int IntegerPatternAction(const char * lexeme) {
    yylval.intNumber = atoi(lexeme);
    return INTEGER;
}

int DoublePatternAction(const char * lexeme) {
    yylval.doubleNumber = atof(lexeme);
    return DOUBLE;
}

int StringPatternAction(char * lexeme) {
    char * aux = malloc(strlen(lexeme) + 1);
    AddMalloc(aux);
    strcpy(aux, lexeme);
    yylval.string = aux;
    return ID;
}

int EscapeStringPatternAction(char * lexeme) {
    char * aux = malloc(strlen(lexeme) + 1);
    AddMalloc(aux);
    strcpy(aux, lexeme);
    yylval.string = aux;
    return ESCAPESTRING;
}

void IgnoredPatternAction() {}

int UnknownPatternAction(const char * lexeme) {
    LogDebug("UnknownPatternAction: '%s'.", lexeme);
    return YYUNDEF;
}
